//=============================================================================
// LiftKicker.
//=============================================================================
class LiftKicker extends Triggers;

var() vector KickVelocity1;
var() vector KickVelocity2;
var() name KickedClasses;
var bool bPreferVelocity2;

simulated function Touch( Actor Other )
{
	local Actor A;

	if ( !Other.IsA(KickedClasses) )
		return;
		
	PendingTouch = Other.PendingTouch;
	Other.PendingTouch = self;
	
	if( Event != '' )
		foreach AllActors( class 'Actor', A, Event )
			A.Trigger( Other, Other.Instigator );
}

simulated function PostTouch( Actor Other )
{
	local vector Push;
	local float rand;
	local float randVelocity2;
	
	rand = FRand();
	randVelocity2 = 0.5;
	
	if (KickVelocity2.Z == 0)
	{
		rand = 0.1;
	}
	else if (bPreferVelocity2 == true)
	{
		randVelocity2 = 0.2;
	}
	
	if ( Other.Physics == PHYS_Falling )
		return;
	
	Push.Z = -1 * Other.Velocity.Z;
	
	if (rand < randVelocity2) {
		Push += KickVelocity1;
	}
	else {
		Push += KickVelocity2;
	}
	
	if ( Other.Physics != PHYS_Swimming && Other.Physics != PHYS_Flying )
		Other.SetPhysics(PHYS_Falling);
		
	Other.Velocity += Push;
}

defaultproperties
{
}
